﻿#targetengine "session"
#include "MT-ScriptLang1-09.jsx"

	var myParentFolder = myGetScriptPath()
	TestMyLoad = false
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+localize(Message1), "MT-Script 1-09", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainConvert()}
				else {alert(GlStr, "MT-Script 1-09", true)}
		} 


//+++++++++++++++++++++++++++++++++++++++++++++++//

function mainConvert() {
	DetectAllDoubleLink()
	main_Export()
	}


//+++++++++++++++++++++++++++++++++++++++++++++++//

function main_Export() {
	
		#include "MT-Load1-09.jsx"
		
		app.scriptPreferences.enableRedraw = false
	
		var IsSelected = false
		var myConfirmCode = true
		var LoadNum = 0
		var ImportNum = 0
		
		with (app.activeDocument.viewPreferences)
			{
				myOldXUnits = horizontalMeasurementUnits;
				myOldYUnits = verticalMeasurementUnits;

				horizontalMeasurementUnits = MeasurementUnits.POINTS;
				verticalMeasurementUnits = MeasurementUnits.POINTS;
			}
		
		if (($.locale).search("ru") != -1) {
			var myStrInfo = "#MTEF-Start#\r"
			myStrInfo += "Последовательность Ваших действий должна быть следующей:\r"
			myStrInfo += "1. Конвертируйте формулы из текстового вида в OLE-формулы командой Convert Equations... из меню MathType.\r"
			myStrInfo += "Все необходимые установки скрипт делает автоматически. Просто нажмите кнопку Convert\r"
			myStrInfo += "2. Командой Format Equations из меню MathType примените новые установки, используя preference file.\r"
			myStrInfo += "3. Экспортируйте формулы командой Export Equations из меню MathType в папку /Temp-MTEF-Export,\r"
			myStrInfo += "созданную этим скриптом и расположенную в папке с вашей публикацией.\r"
			myStrInfo += "Путь к этой папке, а также необходимые установки скрипт делает автоматически.\r"
			myStrInfo += "Вам необходимо лишь выбрать тип экспортируемых файлов - EPS или WMF.\r"
			myStrInfo += "4. Сохраните этот файл (MTEF-Export.txt) в папку /Temp-MTEF-Export обязательно в текстовом формате (Обычный текст).\r"
			myStrInfo += "Для этого достаточно начать закрывать Word. На вопрос о сохранении файла ответьте ДА, на вопрос о сохранении в исходном формате - тоже ДА.\r"
			myStrInfo += "Обратите внимание, что пока Word не закрыт, дальнейшая работа скрипта и InDesign невозможна.\r"
			myStrInfo += "Далее скрипт сам заменит нужные формулы и обработает их.\r"
			myStrInfo += "Успехов!"
			}
		
		if (($.locale).search("en") != -1) {
			var myStrInfo = "#MTEF-Start#\r"
			myStrInfo += "Please, read about your next steps.\r"
			myStrInfo += "Don't change anything in this file manually.\r"
			myStrInfo += "1. Please, convert equations from like text view equations to OLE-objects by command 'Convert Equations...' from menu 'MathType' in main Word menu.\r"
			myStrInfo += "All setting script will done automaticall. Simply choose command 'Convert Equation...' from menu 'MathType'\r"
			myStrInfo += "2. Using command 'Format Equations' from menu MathType choose new preference MathType-file and apply it to equations in Word window.\r"
			myStrInfo += "3. Use command 'Export Equations' from menu MathType to folder '/Temp-MTEF-Export',\r"
			myStrInfo += "which was created by the script and placed in your publication folder.\r"
			myStrInfo += "The path to this folder and necessary settings script will done automatically.\r"
			myStrInfo += "You would choose only type of exporting equation's files (EPS or WMF).\r"
			myStrInfo += "4. Save this 'MTEF-Export.txt' into the folder '/Temp-MTEF-Export' only as text file (not *.doc, *.rtf - only unformatted txt, please).\r"
			myStrInfo += "To do this correctly start closing Word. Answer 'Yes' on the Word's question about saving file. On the next Word's question about file's format answer 'Yes' too.\r"
			myStrInfo += "Simply 'Yes' and 'Yes'. Be carefull, untill Word is running the next work of this script and InDesign is impossible.\r"
			myStrInfo += "Then script replace necessary files and treat it.\r"
			}
				
		var myDocument = app.activeDocument;
		var myLoadStr = ""
		var myDocPath = myDocument.filePath;
		myOutFolderPath = myDocPath + "/Temp-MTEF-Export/"	
		myOutFolder = new Folder(myOutFolderPath)
		if (!myOutFolder.exists) {myOutFolder.create()}
	
		var FileNameOut  = myOutFolderPath + "MTEF-Export.txt"

		var OutFile = new File(FileNameOut)

if (OutFile.open('w')) {
		OutFile.writeln(myStrInfo)
		try {
			var mySelections = myDocument.selection
			SelectionsLength = mySelections.length

			SelL = 0
	
			do {
		
			var mySelection = mySelections[SelL]
			IsSelected = true // Говорит от том, что объект mySelection существует, иначе рассматривать всю публикацию
			switch (mySelection.constructor.name) {
				case "Text":
				case "Paragraph":
				case "Cell":
					var myStory = mySelection	
							var myTablesInStory = myStory.tables
								for (var i = 0; i < myTablesInStory.length; i++) {
									var myTableCells = myTablesInStory[i].cells
										for (var j = 0; j < myTableCells.length; j++) {
											var myCellText = myTableCells[j].texts[0]
											if (myCellText.contents != "") {
												LoadNum += SaveFormula(myCellText, OutFile)
												}
											}
									}			
					if (myStory.contents != "") {
						LoadNum += SaveFormula(myStory, OutFile)
						}
					break;
			
				case "TextStyleRange":
				case "TextFrame":
				case "TextColumn":
					var myStory = mySelection
							var myTablesInStory = myStory.tables
								for (var i = 0; i < myTablesInStory.length; i++) {
									var myTableCells = myTablesInStory[i].cells
										for (var j = 0; j < myTableCells.length; j++) {
											var myCellText = myTableCells[j].texts[0]
											if (myCellText.contents != "") {
												LoadNum += SaveFormula(myCellText, OutFile)
												}
											}
									}			
			
					if (myStory.contents != "") {
						LoadNum += SaveFormula(myStory, OutFile)
						}
					break;

				case "Character":
					var myStory = mySelection
					if (myStory.contents != "") {
						LoadNum += SaveFormula(myStory, OutFile)
						}
					break;
			
				case "WMF":
				case "EPS":
					LoadNum += SaveFormula(mySelection.parent, OutFile)    // Ссылка на Rectangle
				break;
		
				case "Rectangle":
					LoadNum += SaveFormula(mySelection, OutFile)
				break;
			
				case "Table":
						var myTableCells = mySelection.cells
						for (var i = 0; i < myTableCells.length; i++) {
							var myCellText = myTableCells[i].texts[0]
							if (myCellText.contents != "") {
								LoadNum += SaveFormula(myCellText, OutFile)
								}
						}		
				break;
				}	
	
				SelL++
	
			}  while (SelL < SelectionsLength) 
	
			} // Конец блока try
		catch(err) {
			if (err.name == "TypeError") {
				myConfirmCode = confirm(localize(Message4), false, "MT-Script 1-09: script MT-Convert1-09");
				if (myConfirmCode) {
					
						IsSelected = false
						
						//Блок экспорта текстообразных формул, свободно лежащих на страницах
						var myPageRecs = myDocument.rectangles
						var myPageRecsLen = myPageRecs.length
						
						for (var iPRec = 0; iPRec < myPageRecsLen; iPRec++) {
							//alert(myPageRecs[iPRec].constructor.name + "  " + myPageRecsLen)
							LoadNum += SaveFormula(myPageRecs[iPRec], OutFile)
							} // Конец блока for (var iPRec = 0; iPRec < myPageRecsLen; iPRec++)
						
						//Блок экспорта текстообразных inline-формул
						var myStories = myDocument.stories
						myStoriesLen = myStories.length
						for (myStL = 0; myStL < myStoriesLen; myStL++) {
							var myStory = myStories.item(myStL)
					
							var myTablesInStory = myStory.tables
								for (var i = 0; i < myTablesInStory.length; i++) {
									var myTableCells = myTablesInStory[i].cells
										for (var j = 0; j < myTableCells.length; j++) {
											var myCellText = myTableCells[j].texts[0]
											if (myCellText.contents != "") {LoadNum += SaveFormula(myCellText, OutFile)}
											}
									} // Конец блока for (var i = 0; i < myTablesInStory.length; i++)

								if (myStory.contents != "") {LoadNum += SaveFormula(myStory, OutFile)}
						} // Конец блока for (myStL = 0; myStL < myStoriesLen; myStL++)
				} // Конец блока if (myConfirmCode)
	
			} // if (err.name == "TypeError") 

		} // Конец блока catch

		OutFile.writeln("#MTEF-End#");
		OutFile.close();
	} //if (OutFile.open('w'))

		if ((myConfirmCode)&&(OutFile.exists)&&(LoadNum != 0)) {
			var myOldFileDataTime = OutFile.modified.getSeconds() + OutFile.modified.getMinutes()*60
				Start_Word_Run(FileNameOut, myOutFolderPath, myContinueFlag)
			var myNewFileDataTime = OutFile.modified.getSeconds() + OutFile.modified.getMinutes()*60
			if (myOldFileDataTime != myNewFileDataTime) { ImportNum = PlaceNewPrefEquations(OutFile, myOutFolderPath, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting, LoadNum) }
				else { MessageWindow(localize(Message12)) }
			} //if ((myConfirmCode)&&(OutFile.exists))
		
		app.scriptPreferences.enableRedraw = true
		
		with (app.activeDocument.viewPreferences) {
			horizontalMeasurementUnits = myOldXUnits
			verticalMeasurementUnits = myOldYUnits
			}
		
		if (LoadNum != 0) {alert("Отправлено на обработку " + LoadNum + " формул.\nОбработано и реимпортировано " + ImportNum + " формул.\nПроблемы возникли с " + (LoadNum - ImportNum) + " формулами.", "MT-Script 1-09", false)}
		else {if (myConfirmCode) {alert("В выделенной области формул нет.\nОбрабатывать нечего.", "MT-Script 1-09", false)}}
}


//+++++++++++++++++++++++++++++++++++++++++++++++//

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}




