﻿#targetengine "session"
#include "MT-ScriptLang1-09.jsx"

	var myParentFolder = myGetScriptPath()
	TestMyLoad = false
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+localize(Message1), "MT-Script 1-09", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainNew()}
			else {alert(GlStr, "MT-Script 1-09", true)}
		}


//+++++++++++++++++++++++++++++++++++++++++++++++//


function mainNew() {	
	
	#include "MT-Load1-09.jsx"
	
   var myDocument = app.activeDocument

   with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    } 
	
try {
    var mySelection = myDocument.selection[0]
	switch (mySelection.constructor.name) {
		case "Rectangle":
		case "WMF":
		case "EPS":
			myEditEqScript = new File(myParentFolder+"/MT-EditEq1-09.jsxbin")
			
			if (!myEditEqScript.exists) {
				myEditEqScript = new File(myParentFolder+"/MT-EditEq1-09.jsx")
				}
			if (myEditEqScript.exists) {app.doScript(myEditEqScript, ScriptLanguage.JAVASCRIPT)}
				else {alert(localize(Message17), "MT-Script 1-09", true)}
			break;
		case "Text":
		case "TextStyleRange":
		case "Paragraph":
		case "InsertionPoint":
		case "Character":
		case "Cell":
				if ((myDopShiftingFlag)&&(myTransactionFlag)) {
							var IsItSingleBefore = IsItSingleLine(mySelection)
							var LineTypeBefore = IsItSingleBefore[0]
							var myLineBefore = IsItSingleBefore[1]
							}
			
			if (MyNewEquation_VBA(mySelection, myContinueFlag) == true)  {
				 TreatObject(app.activeDocument.links.item(-1).parent.parent.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)

				if ((myDopShiftingFlag)&&(myTransactionFlag)) {
							var IsItSingleAfter = IsItSingleLine(app.activeDocument.links.item(-1).parent.parent.parent)
							var LineTypeAfter = IsItSingleAfter[0]
							var myLineAfter = IsItSingleAfter[1]

							if ((LineTypeBefore == true)&&(LineTypeAfter == false)) {
								TreatObject(myLineBefore, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
							if ((LineTypeBefore == false)&&(LineTypeAfter == true)) {
								TreatObject(myLineAfter, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
						} // end if () {    
					
				 }
			break;
		}	
	}
    catch(err)
	{ 
		if (err.description.search("undefined") == 0) {
			var myActivePage = myDocument.layoutWindows[0].activePage
		
			NewFilePath = FindFreeEquation(myPath, myContinueFlag)
			if (NewFilePath != "") {
				
				var myNewFile = File(NewFilePath)
				var myOldFileDataTime = myNewFile.modified.getSeconds() + myNewFile.modified.getMinutes()*60
				
				Start_MathType_Run (NewFilePath)

				if (myContinueFlag) {MyDialog(localize(Message18))}
				
				var myNewFileDataTime = myNewFile.modified.getSeconds() + myNewFile.modified.getMinutes()*60
				
				if (myOldFileDataTime != myNewFileDataTime) {
					
						var myNewRectangle = myActivePage.rectangles.add()
			
						myNewRectangle.place(myNewFile)
				
						Formula_Resize(myNewRectangle, dopBaseShift, ScaleFormula, myScaleFlag)
						
					} else { 
						MessageWindow(localize(Message19));
						myNewFile.remove() }					
			}
		
		} else {alert(err,  localize(Message13), true)}
		
		}
		
   with (app.activeDocument.viewPreferences) {

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }
	
	}


// ++++++++++++++++++++++++++ //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}

// ++++++++++++++++++++++++++ //

	