﻿#targetengine "session"
#include "MT-ScriptLang1-09.jsx"

	var myParentFolder = myGetScriptPath()
	TestMyLoad = false
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+localize(Message1), "MT-Script 1-09", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainEdit()}
				else {alert(GlStr, "MT-Script 1-09", true)}
		} 


// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ //

function mainEdit() {
	
	#include "MT-Load1-09.jsx"
	
   var myDocument = app.activeDocument

   with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    } 
	
try {
    var mySelection = myDocument.selection[0]

	switch (mySelection.constructor.name) {
		case "Rectangle":
			
			if (!myScaleFlag) {
				ScaleFormula = mySelection.graphics.item(0).verticalScale
				myScaleFlag = !myScaleFlag}
			
			if (EditMyEquation(mySelection, myDoubleFlag, myContinueFlag) == true) {
					switch (mySelection.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (mySelection, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						if ((myDopShiftingFlag)&&(myTransactionFlag)) {
							var IsItSingleBefore = IsItSingleLine(mySelection)
							var LineTypeBefore = IsItSingleBefore[0]
							var myLineBefore = IsItSingleBefore[1]
							}

						TreatObject(mySelection.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						
						if ((myDopShiftingFlag)&&(myTransactionFlag)) {
							var IsItSingleAfter = IsItSingleLine(mySelection)
							var LineTypeAfter = IsItSingleAfter[0]
							var myLineAfter = IsItSingleAfter[1]

							if ((LineTypeBefore == true)&&(LineTypeAfter == false)) {
								TreatObject(myLineBefore, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
							if ((LineTypeBefore == false)&&(LineTypeAfter == true)) {
								TreatObject(myLineAfter, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
						} // end if (+++++) {    
						break;
					}
				}

		break;
			
		case "WMF":
		case "EPS":

			if (!myScaleFlag) {
				ScaleFormula = mySelection.verticalScale
				myScaleFlag = !myScaleFlag}

			var myObject = mySelection.parent
			
			if (EditMyEquation(myObject, myDoubleFlag, myContinueFlag) == true) {
				//alert("Выделен " + myObject.parent.constructor.name);
					switch (myObject.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (myObject, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						TreatObject(myObject.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						
						if ((myDopShiftingFlag)&&(myTransactionFlag)) {
							var IsItSingleAfter = IsItSingleLine(myObject)
							var LineTypeAfter = IsItSingleAfter[0]
							var myLineAfter = IsItSingleAfter[1]
							
							if ((LineTypeBefore == true)&&(LineTypeAfter == false)) {
								TreatObject(myLineBefore, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
							if ((LineTypeBefore == false)&&(LineTypeAfter == true)) {
								TreatObject(myLineAfter, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								}
						} // end if (+++++) {    
						break;
					}
				}
			
		break;
		
		default:
			alert(localize(Message14)+ mySelection.constructor.name + localize(Message15), localize(Message13))
		break;
		}	
	}
    catch(err)
	{ alert(err+ localize(Message16), localize(Message13))}
		
   with (app.activeDocument.viewPreferences) {

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }
	
	}


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}



	