﻿#targetengine "session"
//Блок инициализации основные параметров скрипта, считывание ini-файла

if (BridgeTalk.appName == "indesign") {
	
	$.localize = true;
	//Русский/английский диалоги
	St_Mes1 = {en: "ATTENTION! In the course of loading InDesign this message will repeat three times.\nStart MT-Dialog1-09 to load the menu",
		ru: "ВНИМАНИЕ! В процессе загрузки InDesign это сообщение будет повторяться три раза.\nЗапустите MT-Dialog1-09, чтобы загрузить меню"}
	St_Mes2 = {en: "&Place equations instead of the text with tags <<>>", ru: "&Разместить формулы вместо текста с тэгами << >>"}
	St_Mes3 = {en: "Place the &new equation", ru: "&Вставить новую формулу"}
	St_Mes4 = {en: "&Edit the equation", ru: "&Исправить формулу"}
	St_Mes5 = {en: "&Test the duplicated equations", ru: "&Проверить дублированные формулы"}
	St_Mes6 = {en: "T&reat the text with equations", ru: "&Обработать текст с формулами"}
	St_Mes7 = {en: "&Batch transformation of equations", ru: "П&акетное преобразование формул"}
	St_Mes8 = {en: "Pre&ferences", ru: "&Установки"}
	St_Mes9 = {en: "It's impossible to start the script", ru: "Не удается запустить скрипт"}
	St_Mes10 = {en: "At least one open document is necessary\nfor work MT-Script1-09", ru: "Для работы MT-Script1-09 необходим\nхотя бы один открытый документ"}

	var myWorkPath = "";
	
	var myIniStartFile = File(Folder.userData + "/mt-start1-09.ini");
	
	if (myIniStartFile.exists == true) {
		if (myIniStartFile.open('r')) {
			myWorkPath = myIniStartFile.readln();
			MathTypePath = myIniStartFile.readln();
			myVersionLang = myIniStartFile.readln();
			myIniStartFile.close();
			if (myVersionLang == "Russian") {$.locale = "ru"} else {$.locale = "en"}
			}
		}
		
	try{
		app.menus.item("$ID/Main").submenus.item("MT-Script1-09").remove();
	}
	catch(myError){}
	
	if (myWorkPath != "") {InitMenu()} else {
			alert(localize(St_Mes1), "MT-Script 1-09", false)}
	
	} // if (Bridge


//+++++++++++++++++++++++++++++++++++++++++++++++//

function InitMenu() {
	
	var myPasteFormula = app.scriptMenuActions.add(localize(St_Mes2));
	var myELPasteFormula = myPasteFormula.eventListeners.add("onInvoke", menuPasteFormula, false);
	
	var myNewFormula = app.scriptMenuActions.add(localize(St_Mes3));
	var myELNewFormula = myNewFormula.eventListeners.add("onInvoke", menuInsertFormula, false);

	var myEditFormula = app.scriptMenuActions.add(localize(St_Mes4));
	var myELEditFormula = myEditFormula.eventListeners.add("onInvoke", menuEditFormula, false);
	
	var myDoubleFormula = app.scriptMenuActions.add(localize(St_Mes5));
	var myELDoubleFormula = myDoubleFormula.eventListeners.add("onInvoke", menuDoubleFormula, false);

	var myTreatFormula = app.scriptMenuActions.add(localize(St_Mes6));
	var myELTreatFormula = myTreatFormula.eventListeners.add("onInvoke", menuTreatFormula, false);
	
	var myConvertFormula = app.scriptMenuActions.add(localize(St_Mes7));
	var myELConvertFormula = myConvertFormula.eventListeners.add("onInvoke", menuConvertFormula, false);
	
	var myPrefFormula = app.scriptMenuActions.add(localize(St_Mes8));
	var myELPrefFormula = myPrefFormula.eventListeners.add("onInvoke", menuPrefFormula, false);


	//If the submenu "Script Menu Action" does not already exist, create it.
	try{
		var myMTScriptMenu = app.menus.item("$ID/Main").submenus.item("MT-Script1-09");
		myMTScriptMenu.title;
	}
	catch (myError){
		var myMTScriptMenu = app.menus.item("$ID/Main").submenus.add("MT-Script1-09");
		var myPasteFormulaMenuItem = myMTScriptMenu.menuItems.add(myPasteFormula);
		var myMenuSeparatorMenuItem = myMTScriptMenu.menuSeparators.add();
		var myNewFormulaMenuItem = myMTScriptMenu.menuItems.add(myNewFormula);
		var myEditFormulaMenuItem = myMTScriptMenu.menuItems.add(myEditFormula);
		var myMenuSeparatorMenuItem = myMTScriptMenu.menuSeparators.add();
		var myDoubleFormulaMenuItem = myMTScriptMenu.menuItems.add(myDoubleFormula);
		var myTreatFormulaMenuItem = myMTScriptMenu.menuItems.add(myTreatFormula);
		var myConvertFormulaMenuItem = myMTScriptMenu.menuItems.add(myConvertFormula);
		var myMenuSeparatorMenuItem = myMTScriptMenu.menuSeparators.add();
		var myDoubleFormulaMenuItem = myMTScriptMenu.menuItems.add(myPrefFormula);
	}
	
}

//+++++++++++++++++++++++++++++++++++++++++++++++//

	function menuPasteFormula(myEvent) {
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
				myScript = new File(myWorkPath+"/MT-PasteEq1-09.jsxbin")
			
				if (!myScript.exists) {
					myScript = new File(myWorkPath+"/MT-PasteEq1-09.jsx")
					}
			
				if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
					else {
						alert(localize(St_Mes9) + " MT-PasteEq1-09", "MT-Script 1-09", false)
						}
				
			} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
		}

//+++++++++++++++++++++++++++++++++++++++++++++++//

	function menuInsertFormula(myEvent) {
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
			myScript = new File(myWorkPath+"/MT-NewEq1-09.jsxbin")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-NewEq1-09.jsx")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-NewEq1-09", "MT-Script 1-09", false)
					}
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
		}
	
//+++++++++++++++++++++++++++++++++++++++++++++++//
	
	
	function menuEditFormula(myEvent) {
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
			myScript = new File(myWorkPath+"/MT-EditEq1-09.jsx")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-EditEq1-09.jsxbin")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-EditEq1-09", "MT-Script 1-09", false)
					} 
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
	}

//+++++++++++++++++++++++++++++++++++++++++++++++//

	function menuTreatFormula(myEvent) {
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
			
			myScript = new File(myWorkPath+"/MT-TreatEq1-09.jsx")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-TreatEq1-09.jsxbin")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-TreatEq1-09", "MT-Script 1-09", false)
					}
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
	}

//+++++++++++++++++++++++++++++++++++++++++++++++//

	function menuPrefFormula(myEvent) {	
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
			myScript = new File(myWorkPath+"/MT-Dialog1-09.jsx")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-Dialog1-09.jsxbin")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-Dialog1-09", "MT-Script 1-09", false)
					}
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
	}

//+++++++++++++++++++++++++++++++++++++++++++++++//


	function menuDoubleFormula(myEvent) {	
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
			myScript = new File(myWorkPath+"/MT-ClearDoubleLinks1-09.jsx")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-ClearDoubleLinks1-09.jsxbin")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-ClearDoubleLinks1-09", "MT-Script 1-09", false)
					}
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
	}

//+++++++++++++++++++++++++++++++++++++++++++++++//


	function menuConvertFormula(myEvent) {	
		
		var myDocument = app.documents
		
		if (myDocument.length > 0) {
		
			myScript = new File(myWorkPath+"/MT-Convert1-09.jsx")
			
			if (!myScript.exists) {
				myScript = new File(myWorkPath+"/MT-Convert1-09.jsxbin")
				}
			
			if (myScript.exists) {app.doScript(myScript, ScriptLanguage.javascript)}
				else {
					alert(localize(St_Mes9) + " MT-Convert1-09", "MT-Script 1-09", false)
					}
				
		} else {alert(localize(St_Mes10), "MT-Script 1-09", false)}
	
	}

//+++++++++++++++++++++++++++++++++++++++++++++++//




