﻿#targetengine "session"
#include "MT-ScriptLang1-09.jsx"

	var myParentFolder = myGetScriptPath();
	TestMyLoad = false;
	var myResult;
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+ localize(Message1), "MT-Script 1-09", true)
				}
		
	}
	

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainTreat()}
			else {alert(GlStr, "MT-Script 1-09", true)}
		}

//+++++++++++++++++++++++++++++++++++++++++++++++//

function mainTreat() {
	
	#include "MT-Load1-09.jsx"
	
	var myDocument = app.activeDocument
	var OverflowsNum = 0
	app.scriptPreferences.enableRedraw = false	

    with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    }
	
try {
	
	var mySelections = myDocument.selection

		if (mySelections.length > 0) {

		for (var SelL = mySelections.length-1; SelL > -1; SelL--) {
		
			var mySelection = mySelections[SelL]
	
			switch (mySelection.constructor.name) {
				case "Text":
				case "Paragraph":
				case "Cell":
					var myStory = mySelection
			
							var myTablesInStory = myStory.tables
								for (var i = 0; i < myTablesInStory.length; i++) {
									var myTableCells = myTablesInStory[i].cells
										for (var j = 0; j < myTableCells.length; j++) {
											var myCellText = myTableCells[j].texts[0]
											if (myCellText.contents != "") {
												TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
												myCellText.recompose()
												}
											}
									}			
					if (myStory.contents != "") {
						TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						myStory.recompose()
						}
					break;
		
				case "TextFrame":
				case "TextStyleRange":
				case "TextColumn":
					var myStory = mySelection
							var myTablesInStory = myStory.tables
								for (var i = 0; i < myTablesInStory.length; i++) {
									var myTableCells = myTablesInStory[i].cells
										for (var j = 0; j < myTableCells.length; j++) {
											var myCellText = myTableCells[j].texts[0]
											if (myCellText.contents != "") {
												TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
												myCellText.recompose()
												}
											}
									}			
			
					if (myStory.contents != "") {
						TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						myStory.recompose()
						}
					break;
			
				case "InsertionPoint":
					var myStory = GetMyLines(mySelection)
					if (myStory.contents != "") {
						TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						myStory.recompose()
						}
					break;

				case "Character":
					var myStory = mySelection
					if (myStory.contents != "") {
						TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						myStory.recompose()
						}
					break;
			
				case "WMF":
				case "EPS":
					var myObject = mySelection.parent  // Ссылка на Rectangle
			
							switch (myObject.parent.constructor.name) {
							case "Page":
							case "Spread":
								Formula_Resize (myObject, dopBaseShift, ScaleFormula, myScaleFlag)
								break;
							case "Character":
								TreatObject(myObject.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								break;
							}
				break;
		
				case "Rectangle":
							switch (mySelection.parent.constructor.name) {
							case "Page":
							case "Spread":
								Formula_Resize (mySelection, dopBaseShift, ScaleFormula, myScaleFlag)
								break;
							case "Character":
								TreatObject(mySelection.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								break;
							}
				break;
			
				case "Table":
						var myTableCells = mySelection.cells
						for (var i = 0; i < myTableCells.length; i++) {
							var myCellText = myTableCells[i].texts[0]
							if (myCellText.contents != "") {
								TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
								myCellText.recompose()
								}
						}		
					break;
				} // Конец switch
	
			} // Конец цикла по SelL
	
			} // Конец блока if (mySelections.length > 0)
			else {
	
			if (confirm(localize(Message4), false, "MT-Script 1-09: script MT-TreatEq1-09")) {
			
						var myPageRecs = myDocument.rectangles
						var myPageRecsLen = myPageRecs.length
						
						for (var iPRec = 0; iPRec < myPageRecsLen; iPRec++) {
							Formula_Resize (myPageRecs[iPRec], dopBaseShift, ScaleFormula, myScaleFlag)
							}		
						
				var myStories = myDocument.stories
				myStoriesLen = myStories.length
				for (myStL = 0; myStL < myStoriesLen; myStL++) {
					var myStory = myStories.item(myStL)
					
					var myTablesInStory = myStory.tables
						for (var i = 0; i < myTablesInStory.length; i++) {
							var myTableCells = myTablesInStory[i].cells
								for (var j = 0; j < myTableCells.length; j++) {
									var myCellText = myTableCells[j].texts[0]
									if (myCellText.contents != "") {
										TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
										myCellText.recompose()
										}
									}
							}
					
						if (myStory.contents != "") {
							TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
							myStory.recompose()}
					}
			} // Конец блока if (confirm( 
		}  // Конец блока else 

} catch (err) {alert(err, "MT-Script 1-09", true)}
	   
    with (app.activeDocument.viewPreferences) {
      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits
    }
	app.scriptPreferences.enableRedraw = true
}


//+++++++++++++++++++++++++++++++++++++++++++++++//

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}

